
Redmine - Patch #30448

Remove wrapper2 and wrapper3 wrapping containers

2019-01-16 18:33 - Anonymous

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version: 5.0.0   

Description

I think maybe it would be good to remove the two wrappers (wrapper2 and wrapper3), as there is really no purpose in them, other

than making the need to add specific extra rules just for these containers, because children containers often behave depending on

the rules set to their parent. And so, wrappers can spawn a blocking behaviour for the rules applied to their far inner children in one

way or another.

I think it will be good to leave only the top wrapper (at least for now) which would wrap everything except for the footer container, this

is to achieve sticky footer design later which will be more easily achievable like this, or else footer winds up in the middle of the

screen when there is little to no content on pages (I have quite a big display). The method I'm suggesting is to stretch the html, body

and wrapper 100% in height, by setting height:100% rule to them, and then apply margin-top: -25px to both the footer and 

margin-bottom: -25px to the wrapper.

Then #content containers also will not need min-height: 600px rule in the future.

Related issues:

Related to Redmine - Patch #30231: Operation: "Unwraping The Mine" or conerns... Closed

Related to Redmine - Defect #39802: Fix click event handling in mobile view a... Closed

Associated revisions

Revision 21151 - 2021-08-10 21:59 - Marius BĂLTEANU

Remove wrapper2 and wrapper3 wrapping containers (#30448).

Revision 21266 - 2021-10-28 00:01 - Marius BĂLTEANU

Fix cursor no longer shown as pointer on whole wrapper when flyout menu is active (#30448).

Patch Bernhard Rohloff.

Revision 21268 - 2021-11-02 23:01 - Marius BĂLTEANU

Close the flyout menu only when clicking on main (#30448).

History

#1 - 2019-01-16 23:05 - Marius BĂLTEANU

- Related to Patch #30231: Operation: "Unwraping The Mine" or conerns about how elements are wrapped added

#2 - 2019-01-19 13:02 - Anonymous

Update: while developing quick html concept layouts for #30451 (#30451#note-3 and #30451#note-5), I came to conclusion that maybe we don't need

even the first #wrapper as well, things could just be rerouted to body tag and sticky footer feature is also achievable without the wrapper.

#3 - 2019-01-22 07:06 - Go MAEDA

- Assignee set to Jean-Philippe Lang

- Target version set to 4.1.0

div.wrapper2 and div.wrapper3 were added in r3429 and r10794 by Jean-Philippe Lang. We can remove those elements if he is OK.

#4 - 2019-06-20 16:04 - Jean-Philippe Lang

- Target version changed from 4.1.0 to 5.0.0

We remove tags from the layout and some themes may rely on them.

2024-03-13 1/3

https://www.redmine.org/issues/30451
https://www.redmine.org/issues/30451#note-3
https://www.redmine.org/issues/30451#note-5
https://www.redmine.org/projects/redmine/repository/svn/revisions/3429
https://www.redmine.org/projects/redmine/repository/svn/revisions/10794


Better set it to a major release.

#5 - 2019-09-05 20:35 - Anonymous

Actively maintained themes have to be anyway patched on per minor release basis, and not actively maintained themes shouldn't be our

responsibility really. I bet those wrappers aren't even the most important things that may affect things in themes, as even minor releases proven to

break a lot of things already. There is really no point in waiting until 5.0

By the time we ll get to 5.0, the world will move on once again.

#6 - 2021-04-04 23:12 - Marius BĂLTEANU

- Assignee changed from Jean-Philippe Lang to Marius BĂLTEANU

#7 - 2021-07-04 15:31 - Marius BĂLTEANU

- File 0001-Remove-wrapper2-and-wrapper3-wrapping-containers-304.patch added

Updated the patch.

#8 - 2021-08-10 22:02 - Marius BĂLTEANU

- Status changed from New to Closed

Patch committed.

#9 - 2021-10-22 07:25 - Mizuki ISHIKAWA

- File hamburger-menu.png added

After this change, the hamburger menu links that appear when the screen width is narrow no longer work.

Clicking on the Overview, Activity, etc. links in the next image will close the menu without taking you anywhere.

 hamburger-menu.png 

With the change in https://www.redmine.org/projects/redmine/repository/revisions/21151/diff/trunk/public/javascripts/responsive.js, the timing for

closing the menu has been changed from $('#wrapper2').on('click', ... to $('#wrapper').on('click', ... .

The #wrapper2 was an element that did not contain the hamburger menu element(.flyout-menu), but the #wrapper contains the .flyout-menu.

This means that when you click on a link in the menu, it will be judged that you have clicked on the #wrapper, and the process of closing the menu will

be running.

#10 - 2021-10-22 07:57 - Marius BĂLTEANU

- Status changed from Closed to Reopened

#11 - 2021-10-22 08:14 - Mizuki ISHIKAWA

I think the following changes will solve the problem described in #30448#note-9.

The problem only occurs with trunk.

diff --git a/public/javascripts/responsive.js b/public/javascripts/responsive.js

index 0bc5c3452a..ddfaee6fb8 100644

--- a/public/javascripts/responsive.js

+++ b/public/javascripts/responsive.js

@@ -3,9 +3,11 @@

 function openFlyout() {

   $('html').addClass('flyout-is-active');

   $('#wrapper').on('click', function(e){

-    e.preventDefault();

-    e.stopPropagation();

-    closeFlyout();

+    if (!$(e.target).closest('.flyout-menu').length) {

+      e.preventDefault();

+      e.stopPropagation();

+      closeFlyout();

+    }

   });

 }

#12 - 2021-10-22 08:41 - Bernhard Rohloff

I've tested Mizuki's patch right now and it works perfectly.

Additionally, I found a legacy of #wrapper2 in the responsive.css.

Index: public/stylesheets/responsive.css

===================================================================
--- public/stylesheets/responsive.css   (Revision 21256)

+++ public/stylesheets/responsive.css   (Arbeitskopie)

@@ -553,7 +553,7 @@

     content: '\00D7'; /* close glyph */

   }

-  .flyout-is-active #wrapper2 {

+  .flyout-is-active #main {

     /*

      * only relevant for devices with cursor when flyout it active, in order to show,

      * that whole wrapper content is clickable and closes flyout menu

#13 - 2021-10-28 00:10 - Marius BĂLTEANU

Mizuki ISHIKAWA wrote:

I think the following changes will solve the problem described in #30448#note-9.

The problem only occurs with trunk.

[...]

 What do you think about this fix?

diff --git a/public/javascripts/responsive.js b/public/javascripts/responsive.js

index 0bc5c3452..a07737795 100644

--- a/public/javascripts/responsive.js

+++ b/public/javascripts/responsive.js

@@ -2,7 +2,7 @@

 function openFlyout() {

   $('html').addClass('flyout-is-active');

-  $('#wrapper').on('click', function(e){

+  $('#main').on('click', function(e){

     e.preventDefault();

     e.stopPropagation();

     closeFlyout();

#14 - 2021-11-01 02:22 - Mizuki ISHIKAWA

Marius BALTEANU wrote:

What do you think about this fix?

[...]

 It looks good.

Changing it to #main will prevent the menu from closing when you click on the #fotter. However, since the #footer is small, this should not be a

problem.

#15 - 2021-11-02 23:05 - Marius BĂLTEANU

- Status changed from Reopened to Closed

Fix committed, thanks for catching this issue.

#16 - 2023-12-26 00:30 - Go MAEDA

- Related to Defect #39802: Fix click event handling in mobile view after closing flyout menu added

Files

wrapper2-wrapper3-removal.patch 1.91 KB 2019-01-16 Anonymous

0001-Remove-wrapper2-and-wrapper3-wrapping-containers-304.patch3.11 KB 2021-07-04 Marius BĂLTEANU

hamburger-menu.png 112 KB 2021-10-22 Mizuki ISHIKAWA
